//* Texas Instruments ADS 1234 Messverstaerker  *//

#include <inttypes.h>
#include "TI_ADS1234.h"
#include <util/delay.h>


extern volatile uint32_t Millisekunden;

int32_t read_ADS1234(uint8_t volatile *DRDY_P_IN, uint8_t volatile *SCLK_PORT, uint8_t DRDY_pin, uint8_t SCLK_pin)
{
	int32_t result = 0;
	Millisekunden = 0;
//	for (uint8_t j = 0; j < 4; j++)	
//	{
		while ((*DRDY_P_IN & (1<<DRDY_pin)) && (Millisekunden < 60))	// Daten liegen noch nicht an
		{
		}
		if (Millisekunden < 60)
		{
//			_delay_us (100);
			for (uint8_t i = 0; i < 24; i++)
			{
				*SCLK_PORT |= (1<<SCLK_pin);
//			_delay_us (100);
				*SCLK_PORT &= ~(1<<SCLK_pin);
//			_delay_us (100);
				if (*DRDY_P_IN & (1<<DRDY_pin))
					result = (result<<1)|0x01;
//					result |= (1 << (23-i));    // alte version (funktioniert, wird aber schneller)
				else
					result = (result<<1);
//					result &= ~(1 << (23-i));
			}
			*SCLK_PORT |= (1<<SCLK_pin);
//			_delay_us (100);
			*SCLK_PORT &= ~(1<<SCLK_pin);
//			_delay_us (100);
		}
		else
			result = 0xFFFFFFFF;
//	}
	return result;
}



void calibrate(uint8_t volatile *DRDY_P_IN, uint8_t volatile *SCLK_PORT, uint8_t DRDY_pin, uint8_t SCLK_pin)
{
	Millisekunden = 0;
	while ((*DRDY_P_IN & (1<<DRDY_pin)) && (Millisekunden < 51))	// Daten liegen noch nicht an
	{
	}
		for (uint8_t i = 0; i < 26; i++)
		{
			*SCLK_PORT |= (1<<SCLK_pin);
//			_delay_us (100);
			*SCLK_PORT &= ~(1<<SCLK_pin);
//			_delay_us (100);
		}
}
